// TsDemuxer.h: CTsDemuxer NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSDEMUXER_H_)
#define _TSDEMUXER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MediaDecoder.h"
#include "TsStream.h"
#include "TsTable.h"
#include "TsMedia.h"


/////////////////////////////////////////////////////////////////////////////
// TSfR[_(PIDɂ郋[eBOyPAT/PMT)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CTsPacket			TSpPbg
// Output	#0	: CMpeg2Sequence	MPEG2-ESV[PX
// Output	#1	: CAdtsFrame		ADTSt[
/////////////////////////////////////////////////////////////////////////////

class CTsDemuxer : public CMediaDecoder
{
public:
	CTsDemuxer(CDecoderHandler *pDecoderHandler);
	virtual ~CTsDemuxer();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

//protected:	b
	inline const bool RoutePacket(const CTsPacket *pPacket);

	static void CALLBACK OnVideoPesPacket(const CPesPacket *pPacket, const PVOID pParam);
	static void CALLBACK OnAudioPesPacket(const CPesPacket *pPacket, const PVOID pParam);

	static void CALLBACK OnMpeg2Sequence(const CMpeg2Sequence *pSequence, const PVOID pParam);
	static void CALLBACK OnAdtsFrame(const CAdtsFrame *pFrame, const PVOID pParam);

	CTsClockRef m_TsClockRef;

	CPatTable m_PatTable;
	CPmtTable m_PmtTable;

	CPesParser m_VideoPesParser;
	CPesParser m_AudioPesParser;

	CAdtsParser m_AdtsParser;
	CMpeg2Parser m_Mpeg2Parser;

	// fobOp
	DWORD m_PidCountArray[0x1FFF];
};

#endif // !defined(_TSDEMUXER_H_)
